;---------------------------------------------------
; RingZerO 
; proudly present:
; A simple IPC METHOD
; By GEnius
;
; alcuni commenti sono stati direttamente rippati
; dagli esempi del DDK per rendere + semplice
; la comprensione delle sezioni del VXD
; alcune sezioni non sono usate ma sono state ugualmente
; lasciate per scopo didattico
;---------------------------------------------------
.386p
	.xlist
	include	vmm.inc
	include vwin32.inc
	include shell.inc
.list


RINZEName              EQU     <'RINZE VXD      '> ;Must be 16 chars
RINZERev               EQU     00H

RINZE_MAJOR_VERSION    EQU     1
RINZE_MINOR_VERSION    EQU     0


ErrorCode               EQU 0FFFFFFFFh

;******************************************************************************
;                                D A T A
;******************************************************************************

VXD_LOCKED_DATA_SEG
;       Pagelocked data here - try to keep this to a minimum.
VM_Handle   dd 0
jmptable    dd RetSuccess
            dd IPC_SHARE_BLOCK
            dd IPC_LEAVE_BLOCK
            dd IPC_GET_SHARE_BLOCK
            dd IPC_BLOCK_PRESENT
Selector    dd 0 ;selettore al blocco pubblico; 0 se il blocco non  presente
LinAddress  dd 0 ;linear address al blocco pubblico; 0 se il blocco non  presente
SizeAddress dd 0 ; Size of the block in unit di 4kb
VXD_LOCKED_DATA_ENDS


VxD_CODE_SEG
;******************************************************************************
;
;   VXD_Create_VM
;
;   DESCRIPTION:
;       This is a shell for a routine that is called when a virtual
;       machine is created. A typical VxD might perform some action
;       here to prepare for handling the new VM in the system.
;
;   ENTRY:
;       EBX = VM handle
;
;   EXIT:
;       Carry clear to continue creating VM
;       Carry set to abort the creation of the VM
;
;   USES:
;       flags
;
;==============================================================================

BeginProc VXD_Create_VM

        clc                             ;no error - continue
        ret

EndProc VXD_Create_VM

VxD_CODE_ENDS

;******************************************************************************
;              V I R T U A L   D E V I C E   D E C L A R A T I O N
;------------------------------------------------------------------------------
; The VxD declaration statement defines the VxD name, version number,
; control proc entry point, VxD ID, initialization order, and VM API 
; entry points. What follows is a minimal VxD declaration, defining 
; only the name, version, control proc, and an undefined ID. Depending
; on the requirements of the VxD, the following may be added:
;
; - Defined VxD ID: See VXDID.TXT for more information
; - Init order: If your Vxd MUST load before or after a specific VxD,
;               the init order can be defined. See VMM.INC for the
;               definition of the init order of the standard devices.
; - V86,PM API: You may wish to allow application or library code running
;               in a virtual machine to communicate with your VxD directly.
;               See the chapter entitled "VxD APIs (Call-Ins)" in the
;               Virtual Device Adaptation Guide.
;               
;******************************************************************************

VXD_LOCKED_CODE_SEG

DECLARE_VIRTUAL_DEVICE RINZE,  \
        RINZE_MAJOR_VERSION,   \
        RINZE_MINOR_VERSION,   \
        RINZE_Control, ,       \
	UNDEFINED_INIT_ORDER


;******************************************************************************
;                      P A G E   L O C K E D   C O D E
;------------------------------------------------------------------------------
;       Memory is a scarce resource. Use this only where necessary.
;******************************************************************************


;******************************************************************************
;
;   VXD_Control
;
;   DESCRIPTION:
;
;       This is a call-back routine to handle the messages that are sent
;       to VxD's to control system operation. Every VxD needs this function
;       regardless if messages are processed or not. The control proc must
;       be in the LOCKED code segment.
;
;       The Control_Dispatch macro used in this procedure simplifies
;       the handling of messages. To handle a particular message, add
;       a Control_Dispatch statement with the message name, followed
;       by the procedure that should handle the message. 
;
;       The two messages handled in this sample control proc, Device_Init
;       and Create_VM, are done only to illustrate how messages are
;       typically handled by a VxD. A VxD is not required to handle any
;       messages.
;
;   ENTRY:
;       EAX = Message number
;       EBX = VM Handle
;
;==============================================================================

public RINZE_Control
RINZE_Control PROC NEAR

        Control_Dispatch SYS_DYNAMIC_DEVICE_INIT,       RINZE_Device_Init
        Control_Dispatch SYS_DYNAMIC_DEVICE_EXIT,       RINZE_Device_Exit
        Control_Dispatch W32_DEVICEIOCONTROL,           RINZE_ioctl
	clc
	ret

RINZE_Control ENDP


Public RINZE_ioctl
BeginProc RINZE_ioctl
        ; jump to the service pointed by dwIoControlCode
        mov ecx,[esi].dwIoControlCode	; get ioctl code
        cmp ecx,4
        ja  RetSuccess
        jmp dword ptr [jmptable+ecx*4]
        jmp RetSuccess

IPC_SHARE_BLOCK: ;*** servizio IPC_SHARE_BLOCK
;        int 3
    	cmp [LinAddress],0 ;the block exists??
        jz globalize
Errore: mov eax,0 ;Error
        mov ebx, [esi].lpvOutBuffer
        mov dword ptr [ebx], eax
        jmp RetSuccess
globalize:
        mov eax, [esi].lpvInBuffer  ; Parameter
	mov eax,[eax]
        mov ebx,[eax] ; linear address of the  buffer that we can make public
        mov ecx,[eax+4] ; size in 4kb units
        mov [SizeAddress],ecx ;save the size of the block
        shr ebx,12
	VMMCall _LinPageLock <ebx, ecx, PAGEMAPGLOBAL > ;create an Address Alias in shared page table
        cmp eax,0
        jz Errore
        mov [LinAddress], eax

        VMMCall _BuildDescriptorDWORDs, <eax, 1, 0f2h, 0c0h, BDDExplicitDPL> ;create the                ;descriptor to ring 3 data
        VMMCall _Allocate_GDT_Selector, <edx, eax, 0> ;Allocate the GDT
        mov ecx, eax              ; zero in eax and edx if error
        or  ecx, edx
        jz  Errore
        mov [Selector], eax       ; new selector of the block   
        mov ebx, [esi].lpvOutBuffer
        mov dword ptr [ebx], 1
	jmp RetSuccess

IPC_LEAVE_BLOCK: ;*** servizio IPC_LEAVE_BLOCK
;        int 3
        mov eax,[LinAddress]
        or eax, [Selector]
        jz RetSuccess ;the block exists??
        mov eax, [Selector]
        VMMCall _Free_GDT_Selector, <eax, 0> ;Free the GDT selector
        mov eax, [LinAddress]
        mov ebx, [SizeAddress]
        shr eax, 12
        VMMCall _LinPageUnLock <eax, ebx, PAGEMAPGLOBAL > ;remove the shared alias of the page
        mov [LinAddress],0
        mov [SizeAddress],0
        jmp RetSuccess 

IPC_GET_SHARE_BLOCK: ;*** servizio IPC_GET_SHARE_BLOCK
;        int 3
        mov eax, [LinAddress]
        or eax, [SizeAddress] ;the block exists??
        jz Err 
        mov ebx, [esi].lpvOutBuffer
        mov edx, [LinAddress] ;return the Linear Address to the block
        mov [ebx], edx
        mov edx, [Selector] ;return the Selector to the Block
        mov word ptr [ebx+4], dx 
        jmp RetSuccess 
Err:    mov eax,0
        mov ebx, [esi].lpvOutBuffer
        mov [ebx], eax
        mov [ebx+4],ax
        jmp RetSuccess

IPC_BLOCK_PRESENT: ;*** servizio IPC_BLOCK_PRESENT
;        int 3
        mov ecx,0
        mov eax, [LinAddress]
        or eax, [SizeAddress]
        jz noblock ;the block exists?? if no return 0 else go on
        mov ecx,1 ;return 1
noblock:
        mov eax, [esi].lpvOutBuffer
        mov [eax], ecx
        jmp RetSuccess 

RetSuccess: ; All Ok!!
        xor     eax, eax     ;return zero = success
	clc
	ret

EndProc RINZE_ioctl



Public RINZE_Device_Exit
BeginProc RINZE_Device_Exit

	clc
	ret

EndProc RINZE_Device_Exit

VXD_LOCKED_CODE_ENDS



;******************************************************************************
;                  I N I T I A L I Z A T I O N   C O D E
;------------------------------------------------------------------------------
;    Code in the initialization segment is discarded after Init_Complete
;******************************************************************************

VXD_ICODE_SEG

;******************************************************************************
;
;   VXD_Device_Init
;
;   DESCRIPTION:
;       This is a shell for a routine that is called at system BOOT.
;       Typically, a VxD would do its initialization in this routine.
;
;   ENTRY:
;       EBX = System VM handle
;
;   EXIT:
;       Carry clear to indicate load success
;       Carry set to abort loading this VxD
;
;   USES:
;       flags
;
;==============================================================================


BeginProc RINZE_Device_Init

	clc
	ret

EndProc RINZE_Device_Init

VXD_ICODE_ENDS


end
