

comment *----------------------------------------------------------------------



FixScn, Coded by daimos.



What this program will do is to fix dumped file. It will simply copy the

values of VirtualSize to PhysicalSize & RVA to Offset.



To assemble use MASM:

 ml /c /Cp /coff fixscn.asm

 link /subsystem:windows fixscn.obj user32.lib kernel32.lib



------------------------------------------------------------------------------*



.386

.Model Flat, StdCall



Include kernel32.inc

Include windows.inc



.Data



szFileName db 'Notepad.Exe', 0

hFile dd 0

hMapObject dd 0

MapViewAddress dd 0



VirtualSize equ 8

RVA equ 0Ch

PhysicalSize equ 10h

FileOffset equ 14h



.Code

Main:



; Creating a Memory Map File is a handy way of manipulating files.



        invoke CreateFile, addr szFileName, \

                           GENERIC_READ + GENERIC_WRITE, \

                           0, \

                           0, \

                           OPEN_EXISTING, \

                           FILE_ATTRIBUTE_NORMAL, \

                           0



        .IF eax == INVALID_HANDLE_VALUE

        jmp Quit_Program

        .ENDIF



        mov hFile, eax          ; Handle of file



        invoke CreateFileMapping, eax, \

                                  0, \

                                  PAGE_READWRITE, \

                                  0, \

                                  0, \

                                  0

        .IF eax == 0

        jmp Close_File_Handle

        .ENDIF



        mov hMapObject, eax



        invoke MapViewOfFile, eax, \

                              FILE_MAP_WRITE, \

                              0, \

                              0, \

                              0



        .IF eax == 0

        jmp Close_Map_Object

        .ENDIF



        mov MapViewAddress, eax



; Get the address of the PE header.



        add eax, [eax+3Ch]

        mov ebx, eax



; Go to Section Table. Offset is constant (PE header + F8h).



        add ebx, 0F8h

        xor ecx, ecx

        mov cx, word ptr [eax+6h]     ; Get NumberOfSections.



        .REPEAT



          .IF dword ptr [ebx] != 'ssb.'



; Work on VirtualSize & PhysicalSize.



            mov edx, [ebx+VirtualSize]

            .IF dword ptr [ebx+PhysicalSize] < edx

              mov [ebx+PhysicalSize], edx

            .ENDIF



; Work on RVA & FileOffset.



            mov edx, [ebx+RVA]

            mov dword ptr [ebx+FileOffset], edx



          .ENDIF



           dec ecx

           add ebx, 28h



        .UNTIL ecx == 0



        invoke UnmapViewOfFile, MapViewAddress



Close_Map_Object:



        invoke CloseHandle, hMapObject



Close_File_Handle:



        invoke CloseHandle, hFile



Quit_Program:



        invoke ExitProcess, 0



End Main



