#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <mem.h>
#define AREA 32768

FILE *f,*g;
unsigned char *b1,*b2;
char notfound[]="Can't open: %s\n";
char seekerror[]="Seek error: %s\n";
char readerror[]="Read error or end of file: %s\nAborting\n";
long l,cont,ofsrc,ofdest;

void uscita(void)
{
if (b1) free(b1);
if (b2) free(b2);
if (f) fclose(f);
if (g) fclose(g);
}

void main(int argc, char *argv[])
{
        if (atexit(uscita))
           {
           printf("Atexit error\n");
           exit(EXIT_FAILURE);
           }
	if (argc!=6)
           {
           printf("Supcomp v1.0 by Pedro '98\n\n"
           "Usage: supcomp <src> <dest> <offset src> <offset dest> <length>\n"
           "Numbers may be in hex if prefixed by 0x\n\n"
           "The program compares <length> bytes of <src> with the corresponding\n"
           "bytes in <dest> starting from the specified offsets\n"
           "Only differences are written to the output\n");
           exit(EXIT_FAILURE);
           }
	if ((b1=(char *)malloc(AREA))==NULL) exit(EXIT_FAILURE);
	if ((b2=(char *)malloc(AREA))==NULL) exit(EXIT_FAILURE);
	if ((f=fopen(argv[1],"rb"))==NULL)
		{
		printf(notfound,argv[1]);
		exit(EXIT_FAILURE);
		}
	if ((g=fopen(argv[2],"rb"))==NULL)
		{
		printf(notfound,argv[2]);
		exit(EXIT_FAILURE);
		}
        ofsrc=strtol(argv[3],NULL,0);
        ofdest=strtol(argv[4],NULL,0);
	if (fseek(f,ofsrc,SEEK_SET))
		{
		printf(seekerror,argv[1]);
		exit(EXIT_FAILURE);
		}
	if (fseek(g,ofdest,SEEK_SET))
		{
		printf(seekerror,argv[2]);
		exit(EXIT_FAILURE);
		}
        if ((l=strtol(argv[5],NULL,0))==0)
		{
		printf("Wrong length\n");
		exit(EXIT_FAILURE);
		}
	while (l)
		{
		long letti,i;

		if (l>=AREA) letti=AREA;
		else letti=l;
		if (fread(b1,1,letti,f)!=letti)
			{
			printf(readerror,argv[1]);
			exit(EXIT_FAILURE);
			}
		if (fread(b2,1,letti,g)!=letti)
			{
			printf(readerror,argv[2]);
			exit(EXIT_FAILURE);
			}
                for (i=0;i<letti;i++)
                    {
                    if (b1[i]!=b2[i])
                       {
                       printf("%.8lx %.2x - %.8lx %.2x\n",cont+ofsrc+i,
                          (unsigned int)b1[i],cont+ofdest+i,(unsigned int)b2[i]);
                       }
                    }
		l-=letti;
                cont+=letti;
		}
	exit(EXIT_SUCCESS);
}

